aboutsummaryrefslogtreecommitdiff
path: root/boca-1.5.0/doc/problemexamples/multas/run/java
diff options
context:
space:
mode:
authorcassiopc <cassiopc@gmail.com>2012-08-06 15:27:18 +0000
committercassiopc <cassiopc@gmail.com>2012-08-06 15:27:18 +0000
commitd75956684f9599b8daf705b11d67c75186ea7e3f (patch)
treeb22f943e9ab3c6849898e3cf5e9659a7ed24b359 /boca-1.5.0/doc/problemexamples/multas/run/java
parent2c2663e03f56149ad4c909858b93fb3c1ea9f271 (diff)
downloadboca-d75956684f9599b8daf705b11d67c75186ea7e3f.tar.gz
boca-d75956684f9599b8daf705b11d67c75186ea7e3f.zip
moving problem examples to better places and fixing a couple of typos in the problem's interface
Diffstat (limited to 'boca-1.5.0/doc/problemexamples/multas/run/java')
-rwxr-xr-xboca-1.5.0/doc/problemexamples/multas/run/java163
1 files changed, 163 insertions, 0 deletions
diff --git a/boca-1.5.0/doc/problemexamples/multas/run/java b/boca-1.5.0/doc/problemexamples/multas/run/java
new file mode 100755
index 0000000..945f15d
--- /dev/null
+++ b/boca-1.5.0/doc/problemexamples/multas/run/java
@@ -0,0 +1,163 @@
+#!/bin/bash
+# ////////////////////////////////////////////////////////////////////////////////
+# //BOCA Online Contest Administrator
+# // Copyright (C) 2003-2012 by BOCA System (bocasystem@gmail.com)
+# //
+# // This program is free software: you can redistribute it and/or modify
+# // it under the terms of the GNU General Public License as published by
+# // the Free Software Foundation, either version 3 of the License, or
+# // (at your option) any later version.
+# //
+# // This program is distributed in the hope that it will be useful,
+# // but WITHOUT ANY WARRANTY; without even the implied warranty of
+# // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# // GNU General Public License for more details.
+# // You should have received a copy of the GNU General Public License
+# // along with this program. If not, see <http://www.gnu.org/licenses/>.
+# ////////////////////////////////////////////////////////////////////////////////
+#Last modified: 21/july/2012 by cassio@ime.usp.br
+#
+# parameters are:
+# $1 main_class
+# $2 input_file
+# $3 timelimit (limit to run all the repetitions, by default only one repetition)
+# $4 number_of_repetitions_to_run (optional, can be used for better tuning the timelimit)
+# $5 maximum allowed memory (in KBytes)
+#
+# the output of the submission should be directed to the standard output
+#
+# the return code show what happened (according to safeexec):
+# 0 ok
+# 1 compile error
+# 2 runtime error
+# 3 timelimit exceeded
+# 4 internal error
+# 5 parameter error
+# 6 internal error
+# 7 memory limit exceeded
+# 8 security threat
+# 9 runtime error
+# other_codes are unknown to boca: in this case BOCA will present the
+# last line of standard output to the judge
+
+umask 0022
+id -u bocajail >/dev/null 2>/dev/null
+if [ $? == 0 ]; then
+ bocau=`id -u bocajail`
+ bocag=`id -g bocajail`
+ chown bocajail.nogroup .
+else
+ bocau=`id -u nobody`
+ bocag=`id -g nobody`
+ chown nobody.nogroup .
+fi
+if [ "$bocau" == "" -o "$bocag" == "" ]; then
+ echo "error finding user to run script"
+ exit 43
+fi
+
+# this script makes use of safeexec to execute the code with less privilegies
+# make sure that directories below are correct.
+sf=`which safeexec`
+[ -x "$sf" ] || sf=/usr/bin/safeexec
+
+if [ "$1" == "" -o "$2" == "" -o "$3" == "" ]; then
+ echo "parameter problem"
+ exit 43
+fi
+if [ ! -r run.jar ]; then
+ echo "ERROR: file run.jar not found - possible error during compilation"
+ exit 1
+fi
+name="$1"
+if [ "${name##*.}" == "class" -a "${name##*.}" == "CLASS" ]; then
+ echo "WARNING: removing .class file extension"
+fi
+if [ "${name##*.}" == "class" ]; then
+ name=`basename "$1" .class`
+fi
+if [ "${name##*.}" == "CLASS" ]; then
+ name=`basename "$1" .CLASS`
+fi
+input=`basename "$2"`
+if [ ! -r "$input" ]; then
+ echo "$2 not found (or is not in the current dir) or it's not readable"
+ exit 45
+fi
+if [ ! -x $sf ]; then
+ echo "$sf not found or it's not executable"
+ exit 46
+fi
+
+time=$3
+if [ "$time" -gt "0" ]; then
+ let "ttime = $time + 30"
+else
+ time=1
+ ttime=30
+fi
+
+nruns=1
+if [ "$4" != "" -a "$4" -gt "0" ]; then
+nruns=$4
+fi
+maxm=512
+if [ "$5" != "" -a "$5" -gt "0" ]; then
+maxm=${5}
+fi
+
+rm -f stdin0 2>/dev/null
+mv "$input" stdin0
+
+cdir=`pwd`
+echo "Current directory is $cdir" >&2
+echo $cdir | grep -q "/bocajail"
+if [ $? == 0 ]; then
+ cdir=`echo $cdir | sed "s/.*\/bocajail//"`
+ cat <<EOF > runit.sh
+#!/bin/bash
+[ -f /proc/cpuinfo ] || /bin/mount -t proc proc /proc
+#/bin/mount --bind /dev /dev
+[ -d /sys/kernel ] || /bin/mount -t sysfs sysfs /sys
+java=`which java`
+[ -x "$java" ] || java=/usr/bin/java
+if [ ! -x $java ]; then
+ echo "$java not found or it's not executable"
+ exit 47
+fi
+export CLASSPATH=.:./run.jar:$CLASSPATH
+cd $cdir
+$sf -r$nruns -t$time -T$ttime -istdin0 -F256 -u256 -ostdout0 -estderr0 -U$bocau -G$bocag -n0 -C. -f20000 -d20000000 -m20000000 -- $java -Xmx${maxm}M -Xms${maxm}M "$name"
+echo \$? > runit.retcode
+/bin/umount /proc 2>/dev/null
+#/bin/umount /dev
+/bin/umount /sys 2>/dev/null
+EOF
+ chmod 755 runit.sh
+ chroot /bocajail $cdir/runit.sh
+ ret=`cat runit.retcode`
+ if [ "$ret" == "" ]; then
+ echo "Execution error - check autojudging"
+ exit 49
+ fi
+ if [ $ret -gt 10 ]; then
+ echo "> > > > > > > Nonzero return code - possible runtime error - I'M GUESSING IT IS RUNTIME ERROR < < < < < < < <"
+ exit 9
+ fi
+ else
+ echo "CODE NOT BEING CHROOTED. DO NOT RUN THIS ON THE MAIN SERVER" >&2
+ echo "CODE NOT BEING CHROOTED. DO NOT RUN THIS ON THE MAIN SERVER" >&2
+ echo "CODE NOT BEING CHROOTED. DO NOT RUN THIS ON THE MAIN SERVER" >&2
+# $java "$name" < stdin0
+ $sf -r$nruns -t$time -T$ttime -istdin0 -F256 -u256 -U$bocau -G$bocag -ostdout0 -estderr0 -n0 -C. -d20000000 -m20000000 -- $java -cp run.jar -Xmx${maxm}M -Xms${maxm}M "$name"
+ ret=$?
+ fi
+ if [ $ret -gt 10 ]; then
+ echo "> > > > > > > Nonzero return code - possible runtime error - I'M GUESSING IT IS RUNTIME ERROR < < < < < < < <"
+ ret=9
+ fi
+fi
+if [ -f stdout0 ]; then
+ cat stdout0
+fi
+exit $ret